PyLit
*****

`Literate Programming`_ with reStructuredText_

.. epigraph::

   The idea is that you do not document programs (after the fact), but
   write documents that *contain* the programs. [1]_

.. meta::
   :description: Literate Programming with reStructuredText
   :keywords: reStructuredText, Docutils, software development

Features
--------

PyLit (Python Literate) provides a plain but efficient tool for
literate programming: a `bidirectional text/code converter`_.

.. toctree::
   :maxdepth: 2

   features

.. _bidirectional text/code converter: features.html#dual-source
.. _literate programming: literate-programming.html


Documentation
-------------

.. toctree::
   :maxdepth: 1

   usage
   tutorial/index
   examples/index

   literate-programming


Download
--------

.. toctree::
   :maxdepth: 1

   download/index

Project page
------------

The PyLit project is hosted at https://codeberg.org/milde/pylit

Changes
-------

PyLit `versions`_.

Usage, behaviour, and API are not fixed yet.  Ideas and feedback welcome.

The `PyLit source`_ has a chapter on open questions and ideas.

.. _versions: examples/pylit.py.html#changelog

.. _PyLit source: raw/master/pylit.py
.. _open questions: examples/pylit.py.html#open-questions

Copyright
---------

Copyright
  © 2005, 2007, 2015, 2022 Günter Milde.

License
  PyLit is `free software`_, released under the `GNU General Public License`_
  (GPL) version 2 or later.

  PyLit is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the `GNU General Public License`_ for more
  details.

I am using PyLit in my daily work for more than ten years now without major
problems. It works for me, but your mileage might vary.

Remember to back up your data. A version control system is recommended.

.. _`free software`: http://www.gnu.org/philosophy/free-sw.html
.. _`GNU General Public License`: http://www.gnu.org/copyleft/gpl.html


About this site
---------------

The PyLit documentation is created from `reStructuredText`_ sources with
Sphinx_. It is located at https://milde.codeberg.page/PyLit/.

.. _reStructuredText: https://docutils.sourceforge.io/rst.html
.. _Sphinx: https://www.sphinx-doc.org/

.. References

.. [1]  John Max Skaller in a `Charming Python interview`_

.. _Charming Python interview:
    http://www.ibm.com/developerworks/library/l-pyth7.html
